/*
     Library PMIO: A library for stdio/pcio on a PM screen
     Copyright (C) 1994  Colin Jensen
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     Contact addresses:
	Colin Jensen
	email: cjensen@netcom.com
	US mail: 4902 Esguerra Terrace, Fremont CA, 94555
*/
#ifndef include_frame_h
#define include_frame_h

#pragma interface

class Frame
{
  HWND frame;
  int x, y;
  enum mode { 
    normal, 
    absolute_size
  };
  mode frame_mode;
  int is_attached;
  static MRESULT GenericWindowProcedure (HWND, USHORT, MPARAM, MPARAM);
  MRESULT WindowProcedure (int, MPARAM, MPARAM);
  MRESULT (*old_wndproc)(HWND, USHORT, MPARAM, MPARAM);
  MRESULT MsgQueryTrackInfo (unsigned short flags, TRACKINFO *trackinfo);
 public:
  void attach (HWND aframe);
  void set_absolute_size (int ax, int ay);
  Frame ();
};

#endif /* include_frame_h */
