
/*
     Program PM-Info: a program for viewing GNU-style hypertext info
     documentation files.
     Copyright (C) 1992,1993,1994  Colin Jensen
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     Contact addresses:
	Colin Jensen
	email: cjensen@netcom.com
	US mail: 4902 Esguerra Terrace, Fremont CA, 94555
*/

#include <stdlib.h>
#include <string.h>
#include "history.h"

HistoryList::HistoryList(int asize)
     : size(asize), 
       history((char **) malloc(sizeof(char *) * asize)),
       current_size(0),
       current_pos(0)
{
}

char *HistoryList::pop(void)
{
    if (current_size == 0) return NULL;
    current_size--;
    if (current_pos == 0) {
	current_pos = size-1;
    } else {
	current_pos--;
    }
    return history[current_pos];
}

void HistoryList::push(const char *pushval)
{
    
    if (current_size == size) {
	/* free entry before filling */
	free(history[current_pos]);
    } else {
	current_size++;
    }
    history[current_pos++] = strdup(pushval);
    if (current_pos >= size) {
	current_pos = 0;
    }
};
