extproc perl -x

#!perl
$| = 1;
print "Creating new depend file...\n";
open(DEP, ">mkdep.mak");
print DEP "# This file is auto-generated.  Do not edit.\n";
close(DEP);
foreach (@ARGV) {
    if (/^(.+)\.obj/) {
	$filebase = $1;
	if (-e $filebase . ".cc") {
	    $filebase = $filebase . ".cc";
	    print "Depending $filebase\n";
	    system "gcc -MM $filebase >> mkdep.mak";
	    push (@allfiles, $filebase);
	} elsif (-e $filebase . ".c") {
	    $filebase = $filebase . ".c";
	    print "Depending $filebase\n";
	    system "gcc -MM $filebase >> mkdep.mak";
	    push (@allfiles, $filebase);
	} else {
	    print STDERR "mkdep: Unable to find source file for $_\n";
	}
    } else {
	print STDERR "mkdep: Unable to find source file for $_\n";
    }
}

print STDERR "Fixing the output of gcc\n";
unlink("mkdep.bak");
rename("mkdep.mak", "mkdep.bak");
open(IN, "mkdep.bak");
open(OUT, ">mkdep.mak");
while(<IN>) {
    s/\.o :/.obj:/;
    print OUT $_;
}
close(OUT);
close(IN);

print STDERR "Making tags\n";
system ("etags " . join(" ", @allfiles));
1;
