/*
     Library PMIO: A library for stdio/pcio on a PM screen
     Copyright (C) 1994  Colin Jensen
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     Contact addresses:
	Colin Jensen
	email: cjensen@netcom.com
	US mail: 4902 Esguerra Terrace, Fremont CA, 94555
*/
/*
 * Generic Interface to Semaphores
 */


#define INCL_DOSSEMAPHORES
#define INCL_DOSERRORS
#include <os2.h>
#include "pmio2.h"

IO_Interface::IO_Interface ()
{
  DosCreateEventSem (0, &semaphore, 0, FALSE);
}

void IO_Interface::wait ()
{
  int rc;
  do
    {
      rc = DosWaitEventSem (semaphore,
			    (long unsigned int) SEM_INDEFINITE_WAIT);
      /* Retry if an interrupt occurred */
      if (rc == ERROR_INTERRUPT)
	continue;
      /* Otherwise, assume it worked */
    } while (0);
}



