/*
     Library PMIO: A library for stdio/pcio on a PM screen
     Copyright (C) 1994  Colin Jensen
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

     Contact addresses:
	Colin Jensen
	email: cjensen@netcom.com
	US mail: 4902 Esguerra Terrace, Fremont CA, 94555
*/

#include <stdio.h>

#include "pmio.h"
#include "pmio6.h"

static int attach_write (void *, char *buf, int len)
{
  pmio_stdiowrite (len, buf);
  return len;
}

void pmio_attach_stdio (void)
{
  FILE *f;
  
  f = fwopen (0, attach_write);
  if (!f)
    return; /* This should never happen */
  setvbuf (f, 0, _IONBF, 0);
  fclose (stdout);
  fclose (stderr);
  *stdout = *f;
  *stderr = *f;
}
